> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://nemo-platform.docs.buildwithfern.com/nemo/platform/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://nemo-platform.docs.buildwithfern.com/nemo/platform/_mcp/server.

# Add Model Adapter

POST https://host.com/apis/models/v2/workspaces/{workspace}/models/{model_name}/adapters
Content-Type: application/json

Adds an Adapter to the Model

Reference: https://nemo-platform.docs.buildwithfern.com/nemo/platform/nemo/platform/documentation/reference/api-reference/models/create-model-adapter-apis-models-v-2-workspaces-workspace-models-model-name-adapters-post

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Nemo Platform API
  version: 1.0.0
paths:
  /apis/models/v2/workspaces/{workspace}/models/{model_name}/adapters:
    post:
      operationId: >-
        create-model-adapter-apis-models-v-2-workspaces-workspace-models-model-name-adapters-post
      summary: Add Model Adapter
      description: Adds an Adapter to the Model
      tags:
        - subpackage_models
      parameters:
        - name: workspace
          in: path
          required: true
          schema:
            type: string
        - name: model_name
          in: path
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Register a new adapter to the model
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Adapter'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateModelAdapterRequest'
servers:
  - url: https://host.com
    description: Default
components:
  schemas:
    FinetuningType:
      type: string
      enum:
        - lora_merged
        - all_weights
        - last_layer
        - top_layers
        - gradual_unfreezing
        - bias_only
        - attention_only
        - lora
        - qlora
        - adalora
        - dora
        - lora_plus
        - prompt_tuning
        - prefix_tuning
        - p_tuning
        - p_tuning_v2
        - soft_prompt
        - ppo
        - dpo
        - cdpo
        - ipo
        - orpo
        - kto
        - rrhf
        - grpo
      description: Finetuning types.
      title: FinetuningType
    Lora:
      type: object
      properties:
        alpha:
          type: integer
          description: Alpha scaling used for this adapter
        rank:
          type: integer
          description: LoRA Rank
      required:
        - rank
      title: Lora
    CreateModelAdapterRequest:
      type: object
      properties:
        name:
          type: string
          description: >-
            Name of the adapter. Name must be unique in the workspace. Allowed
            characters: letters (a-z, A-Z), digits (0-9), underscores, hyphens,
            and dots.
        description:
          type: string
          description: Optional description of the adapter
        fileset:
          type: string
          description: >-
            Location where adapter files are stored - expected format
            {workspace}/{fileset_name}
        finetuning_type:
          $ref: '#/components/schemas/FinetuningType'
          description: Type of finetuning (LORA, P_TUNING, etc.)
        enabled:
          type: boolean
          default: true
          description: Whether to make this adapter available for inference post training
        lora_config:
          $ref: '#/components/schemas/Lora'
          description: Lora configuration specifics
      required:
        - name
        - fileset
        - finetuning_type
      description: >-
        Request body for nested Adapter creation. The base model comes from the
        URL path, not the body.
      title: CreateModelAdapterRequest
    Adapter:
      type: object
      properties:
        name:
          type: string
          description: >-
            Name of the adapter. Name must be unique in the workspace for all
            Adapters and match the following regex: Allowed characters: letters
            (a-z, A-Z), digits (0-9), underscores, hyphens, and dots.
        workspace:
          type: string
          description: >-
            Workspace of the adapter. Allowed characters: letters (a-z, A-Z),
            digits (0-9), underscores, hyphens, and dots.
        description:
          type: string
          description: Optional description of the adapter
        fileset:
          type: string
          description: >-
            Fileset where the adapter files are stored expected format
            {workspace}/{fileset_name}
        finetuning_type:
          $ref: '#/components/schemas/FinetuningType'
          description: Type of finetuning (LORA, P_TUNING, etc.)
        enabled:
          type: boolean
          default: true
          description: Whether to make this adapter available for inference post training
        lora_config:
          $ref: '#/components/schemas/Lora'
          description: Lora configuration specifics
        model:
          type: string
          description: >-
            Parent model entity reference. A single name (2-63 characters) or
            'workspace/model_name' where each segment is a valid name
            (lowercase, digits, hyphens, and temporarily @ . + _; no
            leading/trailing or consecutive hyphens). If one slash, both sides
            must be non-empty.
        created_at:
          type: string
          format: date-time
        updated_at:
          type: string
          format: date-time
      required:
        - name
        - workspace
        - fileset
        - finetuning_type
      title: Adapter
    ValidationErrorLocItems:
      oneOf:
        - type: string
        - type: integer
      title: ValidationErrorLocItems
    ValidationError:
      type: object
      properties:
        loc:
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorLocItems'
        msg:
          type: string
        type:
          type: string
        input:
          description: Any type
        ctx:
          type: object
          additionalProperties:
            description: Any type
      required:
        - loc
        - msg
        - type
      title: ValidationError
    HTTPValidationError:
      type: object
      properties:
        detail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationError'
      title: HTTPValidationError

```

## Examples



**Request**

```json
{
  "name": "lora-adapter-v1",
  "fileset": "research-team/lora-finetune-v1",
  "finetuning_type": "lora_merged"
}
```

**Response**

```json
{
  "name": "lora-adapter-v1",
  "workspace": "research-team",
  "fileset": "research-team/lora-finetune-v1",
  "finetuning_type": "lora_merged",
  "description": "LoRA adapter fine-tuned on domain-specific dataset",
  "enabled": true,
  "lora_config": {
    "rank": 8,
    "alpha": 16
  },
  "model": "research-team/base-model-v2",
  "created_at": "2024-01-15T09:30:00Z",
  "updated_at": "2024-01-15T09:30:00Z"
}
```

**SDK Code**

```python
import requests

url = "https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters"

payload = {
    "name": "lora-adapter-v1",
    "fileset": "research-team/lora-finetune-v1",
    "finetuning_type": "lora_merged"
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"name":"lora-adapter-v1","fileset":"research-team/lora-finetune-v1","finetuning_type":"lora_merged"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters"

	payload := strings.NewReader("{\n  \"name\": \"lora-adapter-v1\",\n  \"fileset\": \"research-team/lora-finetune-v1\",\n  \"finetuning_type\": \"lora_merged\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"lora-adapter-v1\",\n  \"fileset\": \"research-team/lora-finetune-v1\",\n  \"finetuning_type\": \"lora_merged\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"lora-adapter-v1\",\n  \"fileset\": \"research-team/lora-finetune-v1\",\n  \"finetuning_type\": \"lora_merged\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters', [
  'body' => '{
  "name": "lora-adapter-v1",
  "fileset": "research-team/lora-finetune-v1",
  "finetuning_type": "lora_merged"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"lora-adapter-v1\",\n  \"fileset\": \"research-team/lora-finetune-v1\",\n  \"finetuning_type\": \"lora_merged\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [
  "name": "lora-adapter-v1",
  "fileset": "research-team/lora-finetune-v1",
  "finetuning_type": "lora_merged"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://host.com/apis/models/v2/workspaces/workspace/models/model_name/adapters")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```